



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>(Relax 水题1.2)POJ 1032 Parliament(将n分解成若干个互不相等的整数的和,并且是这些整数的乘积最大)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">(Relax 水题1.2)POJ 1032 Parliament(将n分解成若干个互不相等的整数的和,并且是这些整数的乘积最大)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 21:44:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题意：给出一个数n，将其拆分为若干个互不相等的数字的和，要求这些数字的乘积最大。</p>
<p>分析：我们可以发现任何一个数字，只要能拆分成两个大于1的数字之和，那么这两个数字的乘积一定大于等于原数。也就是说，对于连乘式中，如果将一个乘数a更换为两个数字b&times;c（a=b+c且b&gt;1,c&gt;1），那么乘积只可能增大或不变，不会减小。所以我们拆分的原则就是将这些数字拆得尽量小，拆成许多2的乘积是最好的。又因为题目约束各个数字不能相同，则我们拆分的结果最理想的情况是从2开始的公差为1的等差数列。但是有时是无法构成这样的等差数列的，因为构成到某一位时会出现构建下一位不够用的情况，例如，n=6时，6=2+3+1。当我们要构成4的时候只剩下1了。如果余数是1,那么我们必然要加到前面的某一个数字上，否则乘积无法增大。如果是大于1的数，也必须加在前面的某些数字上，否则如果单乘会出现重复数字。对于一个余数，应该每次将余数中的一个1分配给数列中最小的数字，这样才能使得乘积每次增大的幅度最大，因为增加量是所有除了最小乘数之外的数字的乘积。但是这样做会造成数字重复，所以唯一可以避免数字重复的方法是将这些1从最大的数字开始依次向较小数分配，让每个乘数增加1。但是这样仍然可能有剩余，但最多剩余1,因为再多就足够构成下一个乘数的了，同样为了避免重复，我们只能将这个1加在最大的乘数上。</p>
<pre class="prettyprint linenums">/*<br />
 * POJ_1032.cpp<br />
 *<br />
 *  Created on: 2013年11月25日<br />
 *      Author: Administrator<br />
 */

#include &lt;iostream&gt;<br />
#include &lt;cstdio&gt;

using namespace std;

const int maxn = 1005;<br />
int ans[maxn];

int main(){<br />
	int n;<br />
	while(scanf("%d",&amp;n)!=EOF){

		int total = 0;<br />
		int i = 2;<br />
		while(total + i &lt;= n ){<br />
			total += i;<br />
			ans[i-2] = i;<br />
			++i;<br />
		}

		n -= total;<br />
		i = i-3;<br />
		total = i;

		while(i &gt;= 0 &amp;&amp; n &gt; 0){<br />
			--n;<br />
			ans[i]++;<br />
			--i;<br />
		}

		if(n&gt;0){<br />
			ans[total]++;<br />
		}

		bool first = true;<br />
		for(i = 0 ; i &lt;= total ; ++i){<br />
			if(!first){<br />
				cout&lt;&lt;" ";<br />
			}<br />
			first = false;<br />
			cout&lt;&lt;ans[i];<br />
		}<br />
	}

	return 0;<br />
}
</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1y1l2q.html">Macaca-iOS入门那些事</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8my37o8.html">PMO到底什么样？（3）</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw40mk8.html">C&num;中enum类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql00leq.html">夺命雷公狗-----React---5--props对象的传递</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyjgk2q.html">git学习&lpar;这个我没有整理，是我不断在学习的过程中，自己总结的，对象是我，不过有问题的，我们可以相互交流）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m3d2r9.html">Silverlight 利用DataGrid行加载事件动态控制行列显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnk2eoq.html">Top Android App使用的组件 2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydg4d2q.html">Qt使用Cookies对网站操作之Get和POST</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wgjvoq.html">jquery中ajax向action传递对象参数，json ，spring注入对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z6zk49.html">asp&period;net 导入</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mngkwrq.html">listView 单选实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpo7lvq.html">mysql 4 索引的优缺点</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzrdzw8.html">HI3531的nand flash测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkrjwz8.html">Acperience HDU - 5734</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo71x3q.html">●BZOJ 3676 &lbrack;Apio2014&rsqb;回文串</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoww01q.html">Java IO系列之三：NIO VS IO</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjo46j9.html">ORC Creation Best Practices</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e407rj9.html">Spring 使用介绍（七）&mdash;&mdash; Spring事务</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jnp05q.html">REST风格接口测试利器Wisdom rest-client</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv045k8.html">MySQL----数据库练习</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8z1nz2d9.html">ajax传值</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmvwp49.html">HTML5 离线缓存</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wlpgxq.html">iOS在Cocoa Touch Static Library使用CocoaPods</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7myk2jq.html">How do I size a UITextView to its content&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wlr4vq.html">linux c下几种定时器实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmvlll9.html">Log4Net使用指南（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjo1od9.html">js 判断url的&quest;后参数是否包含某个字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydjekjq.html">js性能优化--学习笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm71n79.html">EclipsePHP Studio 常用设置笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wzj2oq.html">MVC 用法小语法摘录</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
